/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO
 *
 */

package de.ivu.elect.business.datei.boundary;

import javax.persistence.NoResultException;
import javax.persistence.NonUniqueResultException;
import javax.persistence.EntityNotFoundException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import de.ivu.elect.business.datei.entity.DateiExport;
import de.ivu.elect.business.datei.entity.DateiExportUK;

public abstract class AbstractDateiExportDAO extends de.ivu.elect.jee.entity.AbstractDAO<DateiExport,
        de.ivu.elect.business.datei.entity.DateiExportPK
    , DateiExportUK> {

  private static final long serialVersionUID = 1L;

  private static final Logger LOG = LoggerFactory.getLogger(AbstractDateiExportDAO.class);

  public AbstractDateiExportDAO() {
    super();
  }

  public boolean isEntityWithPKPresent(
            de.ivu.elect.business.datei.entity.DateiExportPK
     pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk) != null;
    }

    return false;
  }

  @Override
  public DateiExport findByPrimaryKey(
        de.ivu.elect.business.datei.entity.DateiExportPK
      pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk.getId());
    }

    throw new IllegalArgumentException("PK oder PK.getId() ist null! [pk = " + pk + "]");
  }


  @Override
  protected DateiExport findByPrimaryKey(Long id) {
    if (id == null) {
      throw new IllegalArgumentException("ID ist null! [id = " + id + "]");
    }
  return getEntityManager().find(DateiExport.class, id, CACHE_PROPERTIES);
  }



     /**
      * Name: AllNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM DateiExport o<br>
      * SQL: <br>
      */
     public java.util.List<DateiExport> findByAll() {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  
                              return
                              getEntityManager().
                                createNamedQuery("DATEI_EXPORT.All")
                                                            .getResultList();
                                        
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("DateiExport, findByAll - NonUniqueResultException, Parameter: "
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByAll(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: DateiExportArtAndWahlOrderBeiErstellungszeitpunktDescNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT OBJECT(o) FROM DateiExport o WHERE o.dateiArt=?1 AND o.datei.wahl=?2 ORDER BY o.datei.erstellungszeitpunkt DESC<br>
      * SQL: <br>
      */
     public java.util.List<DateiExport> findByDateiExportArtAndWahlOrderBeiErstellungszeitpunktDesc( @javax.annotation.Nonnull de.ivu.elect.business.exchange.entity.DateiExportArt dateiArt,  @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl,  int limit) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.exchange.entity.DateiExportArt dateiArtCheckedAndAttached =  checkAndAttach(dateiArt, de.ivu.elect.business.exchange.entity.DateiExportArt.class, "dateiArt"); ;
		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("DATEI_EXPORT.DateiExportArtAndWahlOrderBeiErstellungszeitpunktDesc")
                              .setParameter(1, dateiArtCheckedAndAttached)
                                        .setParameter(2, wahlCheckedAndAttached)
                                                  .setMaxResults(limit)
                                        .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByDateiExportArtAndWahlOrderBeiErstellungszeitpunktDesc - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("DateiExport, findByDateiExportArtAndWahlOrderBeiErstellungszeitpunktDesc - NonUniqueResultException, Parameter: "
           + ", dateiArt:'"+dateiArt+"'"
           + ", wahl:'"+wahl+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByDateiExportArtAndWahlOrderBeiErstellungszeitpunktDesc(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: DateiExportArtAndWahlterminOrderBeiErstellungszeitpunktDescNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT OBJECT(o) FROM DateiExport o WHERE o.dateiArt=?1 AND o.datei.wahltermin=?2 ORDER BY o.datei.erstellungszeitpunkt DESC<br>
      * SQL: <br>
      */
     public java.util.List<DateiExport> findByDateiExportArtAndWahlterminOrderBeiErstellungszeitpunktDesc( @javax.annotation.Nonnull de.ivu.elect.business.exchange.entity.DateiExportArt dateiArt,  @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahltermin wahltermin) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  de.ivu.elect.business.exchange.entity.DateiExportArt dateiArtCheckedAndAttached =  checkAndAttach(dateiArt, de.ivu.elect.business.exchange.entity.DateiExportArt.class, "dateiArt"); ;
		  			  de.ivu.elect.business.wahl.entity.Wahltermin wahlterminCheckedAndAttached =  checkAndAttach(wahltermin, de.ivu.elect.business.wahl.entity.Wahltermin.class, "wahltermin"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("DATEI_EXPORT.DateiExportArtAndWahlterminOrderBeiErstellungszeitpunktDesc")
                              .setParameter(1, dateiArtCheckedAndAttached)
                                        .setParameter(2, wahlterminCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("DateiExport, findByDateiExportArtAndWahlterminOrderBeiErstellungszeitpunktDesc - NonUniqueResultException, Parameter: "
           + ", dateiArt:'"+dateiArt+"'"
           + ", wahltermin:'"+wahltermin+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByDateiExportArtAndWahlterminOrderBeiErstellungszeitpunktDesc(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: DateiExportArtOrderBeiErstellungszeitpunktDescNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT OBJECT(o) FROM DateiExport o WHERE o.datei.mandant=?1 AND o.dateiArt=?2 ORDER BY o.datei.erstellungszeitpunkt DESC<br>
      * SQL: <br>
      */
     public java.util.List<DateiExport> findByDateiExportArtOrderBeiErstellungszeitpunktDesc( @javax.annotation.Nonnull de.ivu.elect.business.mandant.entity.Mandant mandant,  @javax.annotation.Nonnull de.ivu.elect.business.exchange.entity.DateiExportArt dateiArt) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.mandant.entity.Mandant mandantCheckedAndAttached =  checkAndAttach(mandant, de.ivu.elect.business.mandant.entity.Mandant.class, "mandant"); ;
		  			  de.ivu.elect.business.exchange.entity.DateiExportArt dateiArtCheckedAndAttached =  checkAndAttach(dateiArt, de.ivu.elect.business.exchange.entity.DateiExportArt.class, "dateiArt"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("DATEI_EXPORT.DateiExportArtOrderBeiErstellungszeitpunktDesc")
                              .setParameter(1, mandantCheckedAndAttached)
                                        .setParameter(2, dateiArtCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByDateiExportArtOrderBeiErstellungszeitpunktDesc - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("DateiExport, findByDateiExportArtOrderBeiErstellungszeitpunktDesc - NonUniqueResultException, Parameter: "
           + ", mandant:'"+mandant+"'"
           + ", dateiArt:'"+dateiArt+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByDateiExportArtOrderBeiErstellungszeitpunktDesc(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: DateiNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM DateiExport o WHERE o.datei = ?1<br>
      * SQL: <br>
      */
     public DateiExport findByDatei( @javax.annotation.Nonnull de.ivu.elect.business.datei.entity.Datei datei) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  de.ivu.elect.business.datei.entity.Datei dateiCheckedAndAttached =  checkAndAttach(datei, de.ivu.elect.business.datei.entity.Datei.class, "datei"); ;
		  
                              return
                    (DateiExport)
                              getEntityManager().
                                createNamedQuery("DATEI_EXPORT.Datei")
                              .setParameter(1, dateiCheckedAndAttached)
                                                                      .getSingleResult();
                                        
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("DateiExport, findByDatei - NonUniqueResultException, Parameter: "
           + ", datei:'"+datei+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByDatei(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }



  @Override
  public boolean isEntityWithUKPresent(de.ivu.elect.business.datei.entity.DateiExportUK uk) {
    try {
      return findByUK(uk) != null;
    } catch (javax.persistence.NoResultException nre) {
      return false;
    }
  }

  @Override
  public boolean isEntityWithUKHasPK(de.ivu.elect.business.datei.entity.DateiExportUK uk,
        de.ivu.elect.business.datei.entity.DateiExportPK
      pk

  ) {
    try {
      return findByUK(uk).getPk().equals(pk);
    } catch (NoResultException ignored) {
      // Do nothing - be happy.
    }
    return true;
  }

    public de.ivu.elect.business.datei.entity.DateiExport findByUK(de.ivu.elect.business.datei.entity.DateiExportUK uk){
        throw new UnsupportedOperationException("Kein UK definiert");
    }


}